// EnvCellSet.h : Declaration of the CEnvCellSet

//

// 11/19/03 Rich Williams - modified for use in SEEK

//



#ifndef __ENVCELLSET_H_

#define __ENVCELLSET_H_



#include "EnvCell.h"

#include "Utilities.h"



#include <scew.h>



// ============================================================================

// EnvCellSet

// ============================================================================



class EnvCellSet

{

private:

  int intCount;

  int intSize;

  EnvCell ** objCells;



  bool resampled;



  // bioclim histograms

  BioclimHistogram * histogram;



public:

  EnvCellSet();

  EnvCellSet(int size);

  virtual ~EnvCellSet();



  void initialize(int size);



  void createBioclimHistogram();

  BioclimHistogram * getBioclimHistogram();



  EnvCellSet * resample();

  void resampleInPlace();



  int size();

  int count();

  int genes();



  void add(EnvCell * cell);

  EnvCell * get(int index);



  char * toXML(char * id);

  void fromXML(char * strXML);

  void fromXML(scew_element const *);



  void toXMLFile(char * strOutputFilename, char *id);

  void fromXMLFile(char * strInputFilename);

};



// ============================================================================

#endif

