/**
 *    '$RCSfile: GarpPrediction.java,v $'
 *
 *     '$Author: berkley $'
 *       '$Date: 2004/01/08 00:48:15 $'
 *   '$Revision: 1.6 $'
 *
 *  For Details: http://kepler.ecoinformatics.org
 *
 * Copyright (c) 2003 The Regents of the University of California.
 * All rights reserved.
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
 * FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY
 * OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
 * UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */

package org.ecoinformatics.seek.garp;

import ptolemy.data.RecordToken;
import ptolemy.data.StringToken;
import ptolemy.data.IntToken;
import ptolemy.data.DoubleToken;
import ptolemy.data.LongToken;
import ptolemy.data.Token;
import ptolemy.actor.gui.EditorPaneFactory;
import ptolemy.data.type.RecordType;
import ptolemy.data.expr.Parameter;
import ptolemy.data.type.BaseType;
import ptolemy.data.type.Type;
import ptolemy.kernel.CompositeEntity;
import ptolemy.kernel.util.*;
import ptolemy.actor.TypedAtomicActor;
import ptolemy.actor.TypedIOPort;
import org.ecoinformatics.seek.workflow.gui.NewActorFrame;
import org.ecoinformatics.seek.garp.GarpJniGlue;
import javax.swing.JOptionPane;

/*<p></p>*/

public class GarpPrediction extends TypedAtomicActor
{
  //input ports
  public TypedIOPort ruleSetFilename = new TypedIOPort(this, "ruleSetFilename",
    true, false);
  public TypedIOPort layerSetFilename = new TypedIOPort(this,
    "layersetFilename", true, false);
  public TypedIOPort outputASCII = new TypedIOPort(this, "outputASCII", true,
    false);
  public TypedIOPort outputBMP = new TypedIOPort(this, "outputBMP", true,
    false);
  //output ports
  public TypedIOPort outputASCIIFileName = new TypedIOPort(this, "outputASCIIFileName",
    false, true);
  public TypedIOPort outputBMPFileName = new TypedIOPort(this, "outputBMPFileName",
    false, true);

  /**
   * GarpPrediction Actor
   */
  public GarpPrediction(CompositeEntity container, String name)
    throws NameDuplicationException, IllegalActionException
  {
    super(container, name);
    ruleSetFilename.setTypeEquals(BaseType.STRING);
    layerSetFilename.setTypeEquals(BaseType.STRING);
    outputASCII.setTypeEquals(BaseType.STRING);
    outputBMP.setTypeEquals(BaseType.STRING);
    outputASCIIFileName.setTypeEquals(BaseType.STRING);
    outputBMPFileName.setTypeEquals(BaseType.STRING);

  }

  /**
   *
   */
  public void initialize()
    throws IllegalActionException
  {
  }

  /**
   *
   */
  public boolean prefire()
    throws IllegalActionException
  {
    return super.prefire();
  }

  /**
   *
   */
  public void fire()
    throws IllegalActionException
  {
    System.out.println("firing GarpPrediction");
    super.fire();

    StringToken ruleSetFilenameToken = (StringToken)ruleSetFilename.get(0);
    String ruleSetFilenameStr = ruleSetFilenameToken.stringValue();

    StringToken layerSetFilenameToken = (StringToken)layerSetFilename.get(0);
    String layerSetFilenameStr = layerSetFilenameToken.stringValue();

    StringToken outputASCIIToken = (StringToken)outputASCII.get(0);
    String outputASCIIStr = outputASCIIToken.stringValue();

    StringToken outputBMPToken = (StringToken)outputBMP.get(0);
    String outputBMPStr = outputBMPToken.stringValue();

    System.out.println("Calling GarpPrediction JNI Code");
    new GarpJniGlue().DoGarpPrediction(ruleSetFilenameStr, layerSetFilenameStr,
      outputASCIIStr, outputBMPStr);

    outputASCIIFileName.broadcast(new StringToken(outputASCIIStr));
    outputBMPFileName.broadcast(new StringToken(outputBMPStr));

    System.out.println("done");
  }
}
